// ʓ` (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>

#include "d88.h"
#include <string.h>

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _offset + _size);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

bool fsave(char *_fname, unsigned char *_pt, int _size)
{
	fp = fopen(_fname,"wb");
	printf ("cutting ... %s\n",_fname);
	fwrite(_pt, 1, _size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{

	unsigned char id1[] = "Tecno X1/(A)";
	char fname[11];
	int i,d;

	struct fpos ma1[] =
	{
		{ 0x4a, 0x01, 0x0800 },	// I[vjO
		{ 0x4a, 0x09, 0x0000 },	// GfBO(ђn/_~[)
		{ 0x4b, 0x01, 0x0b00 },	// C
		{ 0x4c, 0x01, 0x0900 },	// C
		{ 0x4c, 0x0a, 0x0700 },	// X{X
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};
	struct fpos mb1[] =
	{
		{ 0x2e, 0x01, 0x0900 },	// {X
		{ 0x2e, 0x0a, 0x0700 },	// X{X
		{ 0x2f, 0x01, 0x0800 },	// I[vjO
		{ 0x2f, 0x09, 0x0800 },	// GfBO
		{ 0x4d, 0x01, 0x0a00 },	// CBGM
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	disk.SetRecordRange(0x01,0x010);
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x10, 0x01, buff, 0x100);
		if (!memcmp(&buff[0xf0],id1,sizeof(id1)-1))
		{
			printf("Diskuv F܂.\n");
			fcut("OPMDRV", 0x09, 0x04, 0x01, 0x01, 0x01, 0x0000, 0x0c00);
			fcut("PSGDRV", 0x08, 0x04, 0x00, 0x01, 0x01, 0x0000, 0x0c00);

			for (i=0; ma1[i].sec; i++)
			{
				if (i==1) {
					// OPMpGfBOꏈ
					disk.ReadDATA( 0x4a, 0x25, 0x00, 0x09, 0x01, &buff[0x0000], 0x0800);
					disk.ReadDATA( 0x4c, 0x26, 0x00, 0x10, 0x01, &buff[0x0800], 0x0100);
					fsave("MA001", buff, 0x900);
					continue;
				}
				sprintf(fname,"MA0%02d",i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x01, 0x0000, ma1[i].size);
			}
			for (i=0; mb1[i].sec; i++)
			{
				sprintf(fname,"MB0%02d",i);
				fcut(fname, mb1[i].trk, mb1[i].trk>>1, mb1[i].trk&1, mb1[i].sec, 0x01, 0x0000, mb1[i].size);
			}
		}
	}
	return 0;
}

